theory Random1
imports RandomPolicies
begin


declare [[testgen_profiling]]


definition Policy1 where "Policy1 = AllowPortFromTo four five 940 \<oplus>
    AllowPortFromTo one five 663 \<oplus>
    AllowPortFromTo five four 545 \<oplus>
    AllowPortFromTo five three 317 \<oplus>
    AllowPortFromTo four two 467 \<oplus>
    DenyAllFromTo three two \<oplus>
    AllowPortFromTo five three 470 \<oplus>
    DenyAllFromTo five four \<oplus>
    DenyAllFromTo five two \<oplus>
    AllowPortFromTo four five 799 \<oplus>
    AllowPortFromTo one four 641 \<oplus>
    AllowPortFromTo one two 179 \<oplus>
    AllowPortFromTo three four 60 \<oplus>
    AllowPortFromTo five three 523 \<oplus>
    AllowPortFromTo one four 649 \<oplus>
    DenyAllFromTo four one \<oplus>
    AllowPortFromTo two five 956 \<oplus>
    AllowPortFromTo one five 361 \<oplus>
    AllowPortFromTo three two 888 \<oplus>
    AllowPortFromTo five one 371 \<oplus>
    AllowPortFromTo three two 602 \<oplus>
    AllowPortFromTo four one 855 \<oplus>
    AllowPortFromTo five one 700 \<oplus>
    AllowPortFromTo two three 731 \<oplus>
    AllowPortFromTo three five 225 \<oplus>
    AllowPortFromTo four five 109 \<oplus>
    AllowPortFromTo three four 986 \<oplus>
    AllowPortFromTo three one 71 \<oplus>
    AllowPortFromTo one two 927 \<oplus>
    AllowPortFromTo five two 774 \<oplus>
    AllowPortFromTo two four 720 \<oplus>
    AllowPortFromTo three two 551 \<oplus>
    DenyAllFromTo four two \<oplus>
    AllowPortFromTo one five 447 \<oplus>
    AllowPortFromTo two five 387 \<oplus>
    DenyAllFromTo four three \<oplus>
    AllowPortFromTo three four 933 \<oplus>
    AllowPortFromTo three four 537 \<oplus>
    DenyAllFromTo one two \<oplus>
    AllowPortFromTo three one 761 \<oplus>
    AllowPortFromTo three five 263 \<oplus>
    DenyAllFromTo one five \<oplus>
    DenyAllFromTo three four \<oplus>
    AllowPortFromTo five four 318 \<oplus>
    AllowPortFromTo three two 57 \<oplus>
    AllowPortFromTo four five 193 \<oplus>
    AllowPortFromTo five two 951 \<oplus>
    AllowPortFromTo three four 682 \<oplus>
    AllowPortFromTo three four 314 \<oplus> AllowPortFromTo two three 751 \<oplus> DenyAll"

lemma ail7: "all_in_list (policy2list (rotatePolicy Policy1)) (Nets_List (rotatePolicy Policy1))"
apply (unfold Nets_List_def bothNets_def)
apply (insert nets_different, simp add: aux aux2 Policy1_def)
done

definition P10 where "P10 = Policy1"

lemma DAUniv: "dom (CRotate (P \<oplus> DenyAll)) = UNIV"
apply (simp add: PLemmas)
apply (auto simp: PLemmas)
apply (simp split: option.splits decision.splits)
apply auto
apply (simp add: deny_all_def)
done

lemma domSimpl: "dom (C (A \<oplus> DenyAll)) = dom (C (DenyAll))"
apply (simp add: PLemmas)
done



lemma p_eq2R[rule_format]: "normalizeQ (rotatePolicy x) \<noteq> [] \<longrightarrow> 
  C (list2FWpolicy (normalizeQ (rotatePolicy x))) = CRotate x \<longrightarrow>
 list2FWpolicyP (Comb2PolList (rev (normalizeQ (rotatePolicy x))) C) = CRotate x"
apply (simp add: NormalisationIntegerPortProof.p_eq)
done



lemma C_eq_normalizeQRotate: 
"\<lbrakk>DenyAll \<in> set (policy2list p); 
 allNetsDistinct (policy2list (rotatePolicy p));
all_in_list (policy2list (rotatePolicy p)) (Nets_List (rotatePolicy p))\<rbrakk> \<Longrightarrow> 
C (list2FWpolicy (removeAllDuplicates (insertDenies (separate (sort
                   (removeShadowRules2 (remdups (removeShadowRules3 (insertDeny
                  (removeShadowRules1 (policy2list (rotatePolicy p)))))))
(Nets_List (rotatePolicy p)))))))  = CRotate p"
apply (simp add: D_eq_C)
apply (subst NormalisationIntegerPortProof.C_eq_RAD[symmetric])
apply (rule idNMT)
apply (simp add: C_eqLemmas_id)
apply (rule NormalisationIntegerPortProof.C_eq_Until_InsertDenies) 
apply simp_all
apply (erule DAinRotate)
done

lemma C_eq_normalizeQRotate2:
"\<lbrakk>DenyAll \<in> set (policy2list p); 
 allNetsDistinct (policy2list (rotatePolicy p));
all_in_list (policy2list (rotatePolicy p)) (Nets_List (rotatePolicy p))\<rbrakk> \<Longrightarrow> 
C (list2FWpolicy (normalizeQ (rotatePolicy p)))  = CRotate p"
apply (simp add: normalizeQ_def, erule C_eq_normalizeQRotate,simp_all)
done




lemma aND1: "allNetsDistinct (policy2list (rotatePolicy Policy1))"
apply (simp add: Policy1_def UnfoldPolicy netsDistinct nets_distinct_aux allNetsDistinct_def 
                  aND_aux)
apply (simp add: netsDistinct_def in_subnet_def)
apply auto
done

lemma twohelp:"list2FWpolicyP (Comb2PolList (rev (normalizeQ (rotatePolicy Random1.Policy1))) C) x =
    CRotate Random1.Policy1 x"
apply (subst p_eq2R)
apply simp_all
apply (rule NormalisationIntegerPortProof.norm_notMTQ)
apply (simp add: Policy1_def)
apply (rule C_eq_normalizeQRotate2)
apply (simp add: Policy1_def)
apply (rule aND1)
apply (rule ail7)
done


lemma onehelp: " x \<in> (dom (CRotate Random1.Policy1))"
apply (simp add: Policy1_def)
done


lemma noMT21: "\<forall> x \<in> set (policy2list Policy1). dom (C x) \<noteq> {}"
apply (simp add: policies Policy1_def)
apply (simp add: xNotMT UnfoldPolicy)
done



test_spec 
 "FUT x = (CRotate Policy1) x"
apply (prepare_fw_spec)
apply (rule_tac PL = "((Comb2PolList (rev (normalizeQ (rotatePolicy Policy1))) C))" 
   in distrPUTLG1)
apply (rule onehelp)
apply (rule twohelp)
apply (simp only: normalizeQ_def)
apply (subst P10_def[symmetric])
apply (insert noMT21 nets_different, simp add: Nets_List_def bothNets_def
                         aux aux2 Policy1_def, thin_tac "?X",thin_tac "?S")
apply (insert noMT21 nets_different,simp add: P10_def aux aux2 Policy1_def 
        , thin_tac "?X",thin_tac "?S")
apply (simp add: PUTListGD_def)
apply (simp add: gatherDomain_def domain_reasoning dom_2 domDA1)
apply (tactic  
 "REPEAT(CHANGED(TRYALL((rtac @{thm conjI}) THEN' (rtac @{thm impI}))))")
apply (simp_all add: PLemmas UnfoldPolicy)
apply (gen_test_cases FUT)
store_test_thm "Policy1"

declare UnfoldPolicy[simp]
declare PLemmas[simp]

gen_test_data Policy1
thm Policy1.test_data
thm Policy1.pos


declare UnfoldPolicy[simp del]
declare PLemmas[simp del]   

export_fw_data "revRandom.data" Policy1
write_clocks "revRandom1.tex"

end