

theory Random3
imports RandomPolicies
begin


declare [[testgen_profiling]]


lemma ail7: "all_in_list (policy2list (Policy3)) (Nets_List Policy3)"
apply (unfold Nets_List_def bothNets_def)
apply (insert nets_different, simp add: aux aux2 Policy3_def)
done

definition P10 where "P10 = Policy3"




test_spec 
 "FUT x = (C Policy3) x"
apply (prepare_fw_spec)
apply (rule_tac PL = "((map C (rev (normalize (Policy3)))))" 
   in distrPUTLG1)
apply (simp add: Policy3_def domDA1)
apply (rule fun_cong) back
apply (rule NormalisationIntegerPortProof.p_eq2)
apply (rule NormalisationIntegerPortProof.norm_notMT)
apply (simp add: Policy3_def)
apply (rule NormalisationIntegerPortProof.C_eq_normalize)
apply (simp add: Policy3_def)
apply (rule aND3)
apply (rule ail7) 
apply (simp only: normalize_def)
apply (subst P10_def[symmetric])
apply (insert noMT23 nets_different, simp add: Nets_List_def bothNets_def
                         aux aux2 Policy3_def)
apply (simp add: P10_def aux aux2 Policy3_def, thin_tac "?X",thin_tac "?S")
apply (simp add: PUTListGD_def)
apply (simp add: gatherDomain_def domain_reasoning dom_2 domDA1)
apply (tactic  
 "REPEAT(CHANGED(TRYALL((rtac @{thm conjI}) THEN' (rtac @{thm impI}))))")
apply (simp_all add: PLemmas UnfoldPolicy)
apply (gen_test_cases FUT)
store_test_thm "Policy3"

declare UnfoldPolicy[simp]
declare PLemmas[simp]

gen_test_data Policy3

declare UnfoldPolicy[simp del]
declare PLemmas[simp del]   

export_fw_data "Random.data" Policy3
write_clocks "Random3.tex"

end

