

theory Random7
imports RandomPolicies
begin


declare [[testgen_profiling]]


lemma ail7: "all_in_list (policy2list (Policy7)) (Nets_List Policy7)"
apply (unfold Nets_List_def bothNets_def)
apply (insert nets_different, simp add: aux aux2 Policy7_def)
done

definition P10 where "P10 = Policy7"




test_spec 
 "FUT x = (C Policy7) x"
apply (prepare_fw_spec)
apply (rule_tac PL = "((map C (rev (normalize (Policy7)))))" 
   in distrPUTLG1)
apply (simp add: Policy7_def domDA1)
apply (rule fun_cong) back
apply (rule NormalisationIntegerPortProof.p_eq2)
apply (rule NormalisationIntegerPortProof.norm_notMT)
apply (simp add: Policy7_def)
apply (rule NormalisationIntegerPortProof.C_eq_normalize)
apply (simp add: Policy7_def)
apply (rule aND7)
apply (rule ail7) 
apply (simp only: normalize_def)
apply (subst P10_def[symmetric])
apply (insert noMT27 nets_different, simp add: Nets_List_def bothNets_def
                         aux aux2 Policy7_def)
apply (simp add: P10_def aux aux2 Policy7_def, thin_tac "?X",thin_tac "?S")
apply (simp add: PUTListGD_def)
apply (simp add: gatherDomain_def domain_reasoning dom_2 domDA1)
apply (tactic  
 "REPEAT(CHANGED(TRYALL((rtac @{thm conjI}) THEN' (rtac @{thm impI}))))")
apply (simp_all add: PLemmas UnfoldPolicy)
apply (gen_test_cases FUT)
store_test_thm "Policy7"

declare UnfoldPolicy[simp]
declare PLemmas[simp]

gen_test_data Policy7

declare UnfoldPolicy[simp del]
declare PLemmas[simp del]   

export_fw_data "Random.data" Policy7
write_clocks "Random7.tex"

end

