
 
theory 
  prep_nats_norm
imports
  FWTesting
begin



definition
   filter_0 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
  "filter_0 = DenyAll"

definition 
 nat_0  where 
 "nat_0 = (A\<^sub>f (\<lambda>x. {x}))"

definition Adr1 :: "int set" where
 "Adr1 = {d. d > 10 \<and> d < 19}"
definition Adr2 :: "int set" where
 "Adr2 = {d. d > 20 \<and> d < 29}"
definition Adr3 :: "int set" where
 "Adr3 = {d. d > 30 \<and> d < 39}"
definition Adr4 :: "int set" where
 "Adr4 = {d. d > 40 \<and> d < 49}"
definition Adr5 :: "int set" where
 "Adr5 = {d. d > 50 \<and> d < 59}"
definition Adr6 :: "int set" where
 "Adr6 = {d. d > 60 \<and> d < 69}"
definition Adr7 :: "int set" where
 "Adr7 = {d. d > 70 \<and> d < 79}"
definition Adr8 :: "int set" where
 "Adr8 = {d. d > 80 \<and> d < 89}"
definition Adr9 :: "int set" where
 "Adr9 = {d. d > 90 \<and> d < 99}"
definition Adr0 :: "int set" where
 "Adr0 = {d. d > 0 \<and> d < 9}"


definition Adr1b :: "int set" where
 "Adr1b = {d. d > 110 \<and> d < 119}"
definition Adr2b :: "int set" where
 "Adr2b = {d. d > 120 \<and> d < 129}"
definition Adr3b :: "int set" where
 "Adr3b = {d. d > 130 \<and> d < 139}"
definition Adr4b :: "int set" where
 "Adr4b = {d. d > 140 \<and> d < 149}"
definition Adr5b :: "int set" where
 "Adr5b = {d. d > 150 \<and> d < 159}"
definition Adr6b :: "int set" where
 "Adr6b = {d. d > 160 \<and> d < 169}"
definition Adr7b :: "int set" where
 "Adr7b = {d. d > 170 \<and> d < 179}"
definition Adr8b :: "int set" where
 "Adr8b = {d. d > 180 \<and> d < 189}"
definition Adr9b :: "int set" where
 "Adr9b = {d. d > 190 \<and> d < 199}"
definition Adr0b :: "int set" where
 "Adr0b = {d. d > 100 \<and> d < 109}"


definition subnet0 :: "adr\<^isub>i\<^isub>p net" where
 "subnet0 = {{(d,e). d \<in> Adr0 }}"
definition subnet1 :: "adr\<^isub>i\<^isub>p net" where
 "subnet1 = {{(d,e). d \<in> Adr1 }}"
definition subnet2 :: "adr\<^isub>i\<^isub>p net" where
 "subnet2 = {{(d,e). d \<in> Adr2 }}"
definition subnet3 :: "adr\<^isub>i\<^isub>p net" where
 "subnet3 = {{(d,e). d \<in> Adr3 }}"
definition subnet4 :: "adr\<^isub>i\<^isub>p net" where
 "subnet4 = {{(d,e). d \<in> Adr4 }}"
definition subnet5 :: "adr\<^isub>i\<^isub>p net" where
 "subnet5 = {{(d,e). d \<in> Adr5 }}"
definition subnet6 :: "adr\<^isub>i\<^isub>p net" where
 "subnet6 = {{(d,e). d \<in> Adr6 }}"
definition subnet7 :: "adr\<^isub>i\<^isub>p net" where
 "subnet7 = {{(d,e). d \<in> Adr7 }}"
definition subnet8 :: "adr\<^isub>i\<^isub>p net" where
 "subnet8 = {{(d,e). d \<in> Adr8 }}"
definition subnet9 :: "adr\<^isub>i\<^isub>p net" where
 "subnet9 = {{(d,e). d \<in> Adr9 }}"

definition subnet0b :: "adr\<^isub>i\<^isub>p net" where
 "subnet0b = {{(d,e). d \<in> Adr0b }}"
definition subnet1b :: "adr\<^isub>i\<^isub>p net" where
 "subnet1b = {{(d,e). d \<in> Adr1b }}"
definition subnet2b :: "adr\<^isub>i\<^isub>p net" where
 "subnet2b = {{(d,e). d \<in> Adr2b }}"
definition subnet3b :: "adr\<^isub>i\<^isub>p net" where
 "subnet3b = {{(d,e). d \<in> Adr3b }}"
definition subnet4b :: "adr\<^isub>i\<^isub>p net" where
 "subnet4b = {{(d,e). d \<in> Adr4b }}"
definition subnet5b :: "adr\<^isub>i\<^isub>p net" where
 "subnet5b = {{(d,e). d \<in> Adr5b }}"
definition subnet6b :: "adr\<^isub>i\<^isub>p net" where
 "subnet6b = {{(d,e). d \<in> Adr6b }}"
definition subnet7b :: "adr\<^isub>i\<^isub>p net" where
 "subnet7b = {{(d,e). d \<in> Adr7b }}"
definition subnet8b :: "adr\<^isub>i\<^isub>p net" where
 "subnet8b = {{(d,e). d \<in> Adr8b }}"
definition subnet9b :: "adr\<^isub>i\<^isub>p net" where
 "subnet9b = {{(d,e). d \<in> Adr9b }}"

lemmas UnfoldPolicy0 =filter_0_def nat_0_def 
                      NATLemmas 
                      PortCombinators.PortCombinators
                      adr\<^isub>i\<^isub>pLemmas
                      packet_defs 
         

lemmas subnets = subnet1_def subnet2_def subnet3_def subnet4_def
subnet5_def subnet6_def subnet7_def subnet8_def subnet9_def
subnet0_def subnet1b_def subnet2b_def subnet3b_def subnet4b_def
subnet5b_def subnet6b_def subnet7b_def subnet8b_def subnet9b_def
subnet0b_def

lemmas adrs = Adr1_def Adr2_def Adr3_def Adr4_def
Adr5_def Adr6_def Adr7_def Adr8_def Adr9_def
Adr0_def Adr1b_def Adr2b_def Adr3b_def Adr4b_def
Adr5b_def Adr6b_def Adr7b_def Adr8b_def Adr9b_def
Adr0b_def



definition
   filter_1 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where  
  "filter_1 =  (filter_0 \<oplus>  AllowPortFromTo subnet1 subnet1b  (1::port))"


definition nat_1 where
 "nat_1 = nat_0 ++ (srcNat2pool_IntPort Adr1 Adr1b)"


definition policy_1 where
 "policy_1 = ((\<lambda> (x,y). x) o\<^sub>f 
 ((nat_1 \<Otimes>\<^sub>2 C filter_1) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy1 = UnfoldPolicy0 filter_1_def nat_1_def policy_1_def


definition
   filter_2 where
  "filter_2 = filter_1 \<oplus> AllowPortFromTo subnet2 subnet2b  (2::port)"



definition nat_2 where
 "nat_2 = nat_1 ++ (srcPat2pool_IntPort Adr2 Adr2b)"


definition policy_2 where
 "policy_2 = ((\<lambda> (x,y). x) o_f 
 ((nat_2 \<Otimes>\<^sub>2 C filter_2) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy2 = UnfoldPolicy1 filter_2_def nat_2_def policy_2_def

definition
   filter_3  where
  "filter_3 = filter_2 \<oplus> AllowPortFromTo subnet3 subnet3b  (3::port)"



definition nat_3 where
 "nat_3 = nat_2 ++ (srcPat2pool_IntPort Adr3 Adr3b)"


definition policy_3 where
 "policy_3 = ((\<lambda> (x,y). x) o_f 
 ((nat_3 \<Otimes>\<^sub>2C filter_3) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy3 = UnfoldPolicy2 filter_3_def nat_3_def policy_3_def


definition
   filter_4  where
  "filter_4 = filter_3 \<oplus> AllowPortFromTo subnet4 subnet4b (4::port) "


definition nat_4 where
 "nat_4 = nat_3 ++ (srcPat2pool_IntPort Adr4 Adr4b)"


definition policy_4 where
 "policy_4 = ((\<lambda> (x,y). x) o_f 
 ((nat_4 \<Otimes>\<^sub>2 C filter_4) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy4 = UnfoldPolicy3 filter_4_def nat_4_def  policy_4_def


definition
   filter_5  where
  "filter_5 = filter_4 \<oplus> AllowPortFromTo subnet5 subnet5b (5::port) "


definition nat_5 where
 "nat_5 = nat_4 ++ (srcPat2pool_IntPort Adr5 Adr5b)"


definition policy_5 where
 "policy_5 = ((\<lambda> (x,y). x) o_f 
 ((nat_5 \<Otimes>\<^sub>2 C filter_5) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy5 = UnfoldPolicy4 filter_5_def nat_5_def policy_5_def

definition
   filter_6  where
  "filter_6 = filter_5 \<oplus> AllowPortFromTo subnet6 subnet6b (6::port) "


definition nat_6 where
 "nat_6 = nat_5 ++ (srcPat2pool_IntPort Adr6 Adr6b)"


definition policy_6 where
 "policy_6 = ((\<lambda> (x,y). x) o_f 
 ((nat_6 \<Otimes>\<^sub>2 C filter_6) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy6 = UnfoldPolicy5 filter_6_def nat_6_def policy_6_def



definition
   filter_7  where
  "filter_7 = filter_6 \<oplus> AllowPortFromTo subnet7 subnet7b (7::port) "


definition nat_7 where
 "nat_7 = nat_6 ++ (srcPat2pool_IntPort Adr7 Adr7b)"


definition policy_7 where
 "policy_7 = ((\<lambda> (x,y). x) o_f 
 ((nat_7 \<Otimes>\<^sub>2 C filter_7) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy7 = UnfoldPolicy6 filter_7_def nat_7_def policy_7_def

definition
   filter_8  where
  "filter_8 = filter_7 \<oplus> AllowPortFromTo subnet8 subnet8b (8::port) "


definition nat_8 where
 "nat_8 = nat_7 ++ (srcPat2pool_IntPort Adr8 Adr8b)"


definition policy_8 where
 "policy_8 = ((\<lambda> (x,y). x) o_f 
 ((nat_8 \<Otimes>\<^sub>2 C filter_8) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy8 = UnfoldPolicy7 filter_8_def nat_8_def policy_8_def

definition
   filter_9  where
  "filter_9 = filter_8 \<oplus> AllowPortFromTo subnet9 subnet9b (9::port) "


definition nat_9 where
 "nat_9 = nat_8 ++ (srcPat2pool_IntPort Adr9 Adr9b)"


definition policy_9 where
 "policy_9 = ((\<lambda> (x,y). x) o_f 
 ((nat_9 \<Otimes>\<^sub>2 C filter_9) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy9 = UnfoldPolicy8 filter_9_def nat_9_def policy_9_def

definition
   filter_10  where
  "filter_10 = filter_9 \<oplus> AllowPortFromTo subnet0 subnet0b (10::port) "


definition nat_10 where
 "nat_10 = nat_9++ (srcPat2pool_IntPort Adr0 Adr0b)"


definition policy_10 where
 "policy_10 = ((\<lambda> (x,y). x) o_f 
 ((nat_10 \<Otimes>\<^sub>2 C filter_10) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy10 = UnfoldPolicy9 filter_10_def nat_10_def policy_10_def
lemmas filters = filter_0_def filter_1_def filter_2_def filter_3_def filter_4_def filter_5_def filter_6_def filter_7_def filter_8_def filter_9_def filter_10_def



lemma setDistinct1: "x  \<noteq> y \<Longrightarrow> {(a, b). a \<in> x} \<noteq>  {(a, b). a \<in> y}"
apply auto
done


lemma setDaux: "({(d, e). d\<in> adr}  \<noteq> {(d, e).d\<in>adrb}) = (adr \<noteq>  adrb)"
apply auto
done


lemma setDaux1: "\<lbrakk>(b::int) < x; a < b - 1\<rbrakk> \<Longrightarrow> {(d::int). a < d \<and> d < b} \<noteq>  {d. x < d \<and> d < y}"
apply (rule_tac x = "b - 1" in setDistinct)
apply simp
apply simp
done

lemma setDaux2: "\<lbrakk>y < a; x < y - 1\<rbrakk> \<Longrightarrow> {(d::int). a < d \<and> d < b} \<noteq>  {d. x < d \<and> d < y}"
apply (rule not_sym)
apply (rule_tac x = "x + 1" in setDistinct)
apply simp
apply simp
done



lemma nets_distinct_aux:
"a\<inter>b = {} \<Longrightarrow> netsDistinct {{(x,y). x \<in> a}} {{(x,y). x \<in>  b}}"
apply (simp add: netsDistinct_def)
apply (simp add: in_subnet_def)
apply auto
done



fun gen_second where 
 "gen_second  x (y#ys) = (x  y \<and> gen_second x ys)"
|"gen_second x [] = True"

fun net_different_gen where 
 "net_different_gen (x#xs) ys = ((gen_second x ys) \<and> net_different_gen xs ys)"
|"net_different_gen [] ys = True"


lemma nets_different_all: "subnet1 \<noteq> subnet1b \<and> subnet1 \<noteq> subnet2 \<and>
  subnet1 \<noteq> subnet2b \<and> subnet1 \<noteq> subnet3 \<and> subnet1 \<noteq> subnet3b \<and>
  subnet1 \<noteq> subnet4 \<and> subnet1 \<noteq> subnet4b \<and> subnet1 \<noteq> subnet6 \<and> subnet1
  \<noteq> subnet6b \<and> subnet1 \<noteq> subnet7 \<and> subnet1 \<noteq> subnet7b \<and> subnet1 \<noteq>
  subnet8 \<and> subnet1 \<noteq> subnet8b \<and> subnet1 \<noteq> subnet0 \<and> subnet1 \<noteq>
  subnet0b \<and> subnet1 \<noteq> subnet9 \<and> subnet1 \<noteq> subnet9b \<and> subnet1 \<noteq>
  subnet5 \<and> subnet1 \<noteq> subnet5b \<and> subnet1b \<noteq> subnet1 \<and> subnet1b \<noteq>
  subnet2 \<and> subnet1b \<noteq> subnet2b \<and> subnet1b \<noteq> subnet3 \<and> subnet1b \<noteq>
  subnet3b \<and> subnet1b \<noteq> subnet4 \<and> subnet1b \<noteq> subnet4b \<and> subnet1b \<noteq>
  subnet6 \<and> subnet1b \<noteq> subnet6b \<and> subnet1b \<noteq> subnet7 \<and> subnet1b \<noteq>
  subnet7b \<and> subnet1b \<noteq> subnet8 \<and> subnet1b \<noteq> subnet8b \<and> subnet1b \<noteq>
  subnet0 \<and> subnet1b \<noteq> subnet0b \<and> subnet1b \<noteq> subnet9 \<and> subnet1b \<noteq>
  subnet9b \<and> subnet1b \<noteq> subnet5 \<and> subnet1b \<noteq> subnet5b\<and>subnet2 \<noteq>
  subnet1 \<and> subnet2 \<noteq> subnet1b \<and> subnet2 \<noteq> subnet2b \<and> subnet2 \<noteq>
  subnet3 \<and> subnet2 \<noteq> subnet3b \<and> subnet2 \<noteq> subnet4 \<and> subnet2 \<noteq>
  subnet4b \<and> subnet2 \<noteq> subnet6 \<and> subnet2 \<noteq> subnet6b \<and> subnet2 \<noteq>
  subnet7 \<and> subnet2 \<noteq> subnet7b \<and> subnet2 \<noteq> subnet8 \<and> subnet2 \<noteq>
  subnet8b \<and> subnet2 \<noteq> subnet0 \<and> subnet2 \<noteq> subnet0b \<and> subnet2 \<noteq>
  subnet9 \<and> subnet2 \<noteq> subnet9b \<and> subnet2 \<noteq> subnet5 \<and> subnet2 \<noteq>
  subnet5b\<and>subnet2b \<noteq> subnet1 \<and> subnet2b \<noteq> subnet1b \<and> subnet2b \<noteq>
  subnet2 \<and> subnet2b \<noteq> subnet3 \<and> subnet2b \<noteq> subnet3b \<and> subnet2b \<noteq>
  subnet4 \<and> subnet2b \<noteq> subnet4b \<and> subnet2b \<noteq> subnet6 \<and> subnet2b \<noteq>
  subnet6b \<and> subnet2b \<noteq> subnet7 \<and> subnet2b \<noteq> subnet7b \<and> subnet2b \<noteq>
  subnet8 \<and> subnet2b \<noteq> subnet8b \<and> subnet2b \<noteq> subnet0 \<and> subnet2b \<noteq>
  subnet0b \<and> subnet2b \<noteq> subnet9 \<and> subnet2b \<noteq> subnet9b \<and> subnet2b \<noteq>
  subnet5 \<and> subnet2b \<noteq> subnet5b\<and>subnet3 \<noteq> subnet1 \<and> subnet3 \<noteq> subnet1b
  \<and> subnet3 \<noteq> subnet2 \<and> subnet3 \<noteq> subnet2b \<and> subnet3 \<noteq> subnet3b \<and>
  subnet3 \<noteq> subnet4 \<and> subnet3 \<noteq> subnet4b \<and> subnet3 \<noteq> subnet6 \<and> subnet3
  \<noteq> subnet6b \<and> subnet3 \<noteq> subnet7 \<and> subnet3 \<noteq> subnet7b \<and> subnet3 \<noteq>
  subnet8 \<and> subnet3 \<noteq> subnet8b \<and> subnet3 \<noteq> subnet0 \<and> subnet3 \<noteq>
  subnet0b \<and> subnet3 \<noteq> subnet9 \<and> subnet3 \<noteq> subnet9b \<and> subnet3 \<noteq>
  subnet5 \<and> subnet3 \<noteq> subnet5b\<and>subnet3b \<noteq> subnet1 \<and> subnet3b \<noteq>
  subnet1b \<and> subnet3b \<noteq> subnet2 \<and> subnet3b \<noteq> subnet2b \<and> subnet3b \<noteq>
  subnet3 \<and> subnet3b \<noteq> subnet4 \<and> subnet3b \<noteq> subnet4b \<and> subnet3b \<noteq>
  subnet6 \<and> subnet3b \<noteq> subnet6b \<and> subnet3b \<noteq> subnet7 \<and> subnet3b \<noteq>
  subnet7b \<and> subnet3b \<noteq> subnet8 \<and> subnet3b \<noteq> subnet8b \<and> subnet3b \<noteq>
  subnet0 \<and> subnet3b \<noteq> subnet0b \<and> subnet3b \<noteq> subnet9 \<and> subnet3b \<noteq>
  subnet9b \<and> subnet3b \<noteq> subnet5 \<and> subnet3b \<noteq> subnet5b\<and>subnet4 \<noteq>
  subnet1 \<and> subnet4 \<noteq> subnet1b \<and> subnet4 \<noteq> subnet2 \<and> subnet4 \<noteq>
  subnet2b \<and> subnet4 \<noteq> subnet3 \<and> subnet4 \<noteq> subnet3b \<and> subnet4 \<noteq>
  subnet4b \<and> subnet4 \<noteq> subnet6 \<and> subnet4 \<noteq> subnet6b \<and> subnet4 \<noteq>
  subnet7 \<and> subnet4 \<noteq> subnet7b \<and> subnet4 \<noteq> subnet8 \<and> subnet4 \<noteq>
  subnet8b \<and> subnet4 \<noteq> subnet0 \<and> subnet4 \<noteq> subnet0b \<and> subnet4 \<noteq>
  subnet9 \<and> subnet4 \<noteq> subnet9b \<and> subnet4 \<noteq> subnet5 \<and> subnet4 \<noteq>
  subnet5b\<and>subnet4b \<noteq> subnet1 \<and> subnet4b \<noteq> subnet1b \<and> subnet4b \<noteq>
  subnet2 \<and> subnet4b \<noteq> subnet2b \<and> subnet4b \<noteq> subnet3 \<and> subnet4b \<noteq>
  subnet3b \<and> subnet4b \<noteq> subnet4 \<and> subnet4b \<noteq> subnet6 \<and> subnet4b \<noteq>
  subnet6b \<and> subnet4b \<noteq> subnet7 \<and> subnet4b \<noteq> subnet7b \<and> subnet4b \<noteq>
  subnet8 \<and> subnet4b \<noteq> subnet8b \<and> subnet4b \<noteq> subnet0 \<and> subnet4b \<noteq>
  subnet0b \<and> subnet4b \<noteq> subnet9 \<and> subnet4b \<noteq> subnet9b \<and> subnet4b \<noteq>
  subnet5 \<and> subnet4b \<noteq> subnet5b\<and>subnet6 \<noteq> subnet1 \<and> subnet6 \<noteq> subnet1b
  \<and> subnet6 \<noteq> subnet2 \<and> subnet6 \<noteq> subnet2b \<and> subnet6 \<noteq> subnet3 \<and>
  subnet6 \<noteq> subnet3b \<and> subnet6 \<noteq> subnet4 \<and> subnet6 \<noteq> subnet4b \<and>
  subnet6 \<noteq> subnet6b \<and> subnet6 \<noteq> subnet7 \<and> subnet6 \<noteq> subnet7b \<and>
  subnet6 \<noteq> subnet8 \<and> subnet6 \<noteq> subnet8b \<and> subnet6 \<noteq> subnet0 \<and> subnet6
  \<noteq> subnet0b \<and> subnet6 \<noteq> subnet9 \<and> subnet6 \<noteq> subnet9b \<and> subnet6 \<noteq>
  subnet5 \<and> subnet6 \<noteq> subnet5b\<and>subnet6b \<noteq> subnet1 \<and> subnet6b \<noteq>
  subnet1b \<and> subnet6b \<noteq> subnet2 \<and> subnet6b \<noteq> subnet2b \<and> subnet6b \<noteq>
  subnet3 \<and> subnet6b \<noteq> subnet3b \<and> subnet6b \<noteq> subnet4 \<and> subnet6b \<noteq>
  subnet4b \<and> subnet6b \<noteq> subnet6 \<and> subnet6b \<noteq> subnet7 \<and> subnet6b \<noteq>
  subnet7b \<and> subnet6b \<noteq> subnet8 \<and> subnet6b \<noteq> subnet8b \<and> subnet6b \<noteq>
  subnet0 \<and> subnet6b \<noteq> subnet0b \<and> subnet6b \<noteq> subnet9 \<and> subnet6b \<noteq>
  subnet9b \<and> subnet6b \<noteq> subnet5 \<and> subnet6b \<noteq> subnet5b\<and>subnet7 \<noteq>
  subnet1 \<and> subnet7 \<noteq> subnet1b \<and> subnet7 \<noteq> subnet2 \<and> subnet7 \<noteq>
  subnet2b \<and> subnet7 \<noteq> subnet3 \<and> subnet7 \<noteq> subnet3b \<and> subnet7 \<noteq>
  subnet4 \<and> subnet7 \<noteq> subnet4b \<and> subnet7 \<noteq> subnet6 \<and> subnet7 \<noteq>
  subnet6b \<and> subnet7 \<noteq> subnet7b \<and> subnet7 \<noteq> subnet8 \<and> subnet7 \<noteq>
  subnet8b \<and> subnet7 \<noteq> subnet0 \<and> subnet7 \<noteq> subnet0b \<and> subnet7 \<noteq>
  subnet9 \<and> subnet7 \<noteq> subnet9b \<and> subnet7 \<noteq> subnet5 \<and> subnet7 \<noteq>
  subnet5b\<and>subnet7b \<noteq> subnet1 \<and> subnet7b \<noteq> subnet1b \<and> subnet7b \<noteq>
  subnet2 \<and> subnet7b \<noteq> subnet2b \<and> subnet7b \<noteq> subnet3 \<and> subnet7b \<noteq>
  subnet3b \<and> subnet7b \<noteq> subnet4 \<and> subnet7b \<noteq> subnet4b \<and> subnet7b \<noteq>
  subnet6 \<and> subnet7b \<noteq> subnet6b \<and> subnet7b \<noteq> subnet7 \<and> subnet7b \<noteq>
  subnet8 \<and> subnet7b \<noteq> subnet8b \<and> subnet7b \<noteq> subnet0 \<and> subnet7b \<noteq>
  subnet0b \<and> subnet7b \<noteq> subnet9 \<and> subnet7b \<noteq> subnet9b \<and> subnet7b \<noteq>
  subnet5 \<and> subnet7b \<noteq> subnet5b\<and>subnet8 \<noteq> subnet1 \<and> subnet8 \<noteq> subnet1b
  \<and> subnet8 \<noteq> subnet2 \<and> subnet8 \<noteq> subnet2b \<and> subnet8 \<noteq> subnet3 \<and>
  subnet8 \<noteq> subnet3b \<and> subnet8 \<noteq> subnet4 \<and> subnet8 \<noteq> subnet4b \<and>
  subnet8 \<noteq> subnet6 \<and> subnet8 \<noteq> subnet6b \<and> subnet8 \<noteq> subnet7 \<and> subnet8
  \<noteq> subnet7b \<and> subnet8 \<noteq> subnet8b \<and> subnet8 \<noteq> subnet0 \<and> subnet8 \<noteq>
  subnet0b \<and> subnet8 \<noteq> subnet9 \<and> subnet8 \<noteq> subnet9b \<and> subnet8 \<noteq>
  subnet5 \<and> subnet8 \<noteq> subnet5b\<and>subnet8b \<noteq> subnet1 \<and> subnet8b \<noteq>
  subnet1b \<and> subnet8b \<noteq> subnet2 \<and> subnet8b \<noteq> subnet2b \<and> subnet8b \<noteq>
  subnet3 \<and> subnet8b \<noteq> subnet3b \<and> subnet8b \<noteq> subnet4 \<and> subnet8b \<noteq>
  subnet4b \<and> subnet8b \<noteq> subnet6 \<and> subnet8b \<noteq> subnet6b \<and> subnet8b \<noteq>
  subnet7 \<and> subnet8b \<noteq> subnet7b \<and> subnet8b \<noteq> subnet8 \<and> subnet8b \<noteq>
  subnet0 \<and> subnet8b \<noteq> subnet0b \<and> subnet8b \<noteq> subnet9 \<and> subnet8b \<noteq>
  subnet9b \<and> subnet8b \<noteq> subnet5 \<and> subnet8b \<noteq> subnet5b\<and>subnet0 \<noteq>
  subnet1 \<and> subnet0 \<noteq> subnet1b \<and> subnet0 \<noteq> subnet2 \<and> subnet0 \<noteq>
  subnet2b \<and> subnet0 \<noteq> subnet3 \<and> subnet0 \<noteq> subnet3b \<and> subnet0 \<noteq>
  subnet4 \<and> subnet0 \<noteq> subnet4b \<and> subnet0 \<noteq> subnet6 \<and> subnet0 \<noteq>
  subnet6b \<and> subnet0 \<noteq> subnet7 \<and> subnet0 \<noteq> subnet7b \<and> subnet0 \<noteq>
  subnet8 \<and> subnet0 \<noteq> subnet8b \<and> subnet0 \<noteq> subnet0b \<and> subnet0 \<noteq>
  subnet9 \<and> subnet0 \<noteq> subnet9b \<and> subnet0 \<noteq> subnet5 \<and> subnet0 \<noteq>
  subnet5b\<and>subnet0b \<noteq> subnet1 \<and> subnet0b \<noteq> subnet1b \<and> subnet0b \<noteq>
  subnet2 \<and> subnet0b \<noteq> subnet2b \<and> subnet0b \<noteq> subnet3 \<and> subnet0b \<noteq>
  subnet3b \<and> subnet0b \<noteq> subnet4 \<and> subnet0b \<noteq> subnet4b \<and> subnet0b \<noteq>
  subnet6 \<and> subnet0b \<noteq> subnet6b \<and> subnet0b \<noteq> subnet7 \<and> subnet0b \<noteq>
  subnet7b \<and> subnet0b \<noteq> subnet8 \<and> subnet0b \<noteq> subnet8b \<and> subnet0b \<noteq>
  subnet0 \<and> subnet0b \<noteq> subnet9 \<and> subnet0b \<noteq> subnet9b \<and> subnet0b \<noteq>
  subnet5 \<and> subnet0b \<noteq> subnet5b\<and>subnet9 \<noteq> subnet1 \<and> subnet9 \<noteq> subnet1b
  \<and> subnet9 \<noteq> subnet2 \<and> subnet9 \<noteq> subnet2b \<and> subnet9 \<noteq> subnet3 \<and>
  subnet9 \<noteq> subnet3b \<and> subnet9 \<noteq> subnet4 \<and> subnet9 \<noteq> subnet4b \<and>
  subnet9 \<noteq> subnet6 \<and> subnet9 \<noteq> subnet6b \<and> subnet9 \<noteq> subnet7 \<and> subnet9
  \<noteq> subnet7b \<and> subnet9 \<noteq> subnet8 \<and> subnet9 \<noteq> subnet8b \<and> subnet9 \<noteq>
  subnet0 \<and> subnet9 \<noteq> subnet0b \<and> subnet9 \<noteq> subnet9b \<and> subnet9 \<noteq>
  subnet5 \<and> subnet9 \<noteq> subnet5b\<and>subnet9b \<noteq> subnet1 \<and> subnet9b \<noteq>
  subnet1b \<and> subnet9b \<noteq> subnet2 \<and> subnet9b \<noteq> subnet2b \<and> subnet9b \<noteq>
  subnet3 \<and> subnet9b \<noteq> subnet3b \<and> subnet9b \<noteq> subnet4 \<and> subnet9b \<noteq>
  subnet4b \<and> subnet9b \<noteq> subnet6 \<and> subnet9b \<noteq> subnet6b \<and> subnet9b \<noteq>
  subnet7 \<and> subnet9b \<noteq> subnet7b \<and> subnet9b \<noteq> subnet8 \<and> subnet9b \<noteq>
  subnet8b \<and> subnet9b \<noteq> subnet0 \<and> subnet9b \<noteq> subnet0b \<and> subnet9b \<noteq>
  subnet9 \<and> subnet9b \<noteq> subnet5 \<and> subnet9b \<noteq> subnet5b\<and>subnet5 \<noteq> subnet1
  \<and> subnet5 \<noteq> subnet1b \<and> subnet5 \<noteq> subnet2 \<and> subnet5 \<noteq> subnet2b \<and>
  subnet5 \<noteq> subnet3 \<and> subnet5 \<noteq> subnet3b \<and> subnet5 \<noteq> subnet4 \<and> subnet5
  \<noteq> subnet4b \<and> subnet5 \<noteq> subnet6 \<and> subnet5 \<noteq> subnet6b \<and> subnet5 \<noteq>
  subnet7 \<and> subnet5 \<noteq> subnet7b \<and> subnet5 \<noteq> subnet8 \<and> subnet5 \<noteq>
  subnet8b \<and> subnet5 \<noteq> subnet0 \<and> subnet5 \<noteq> subnet0b \<and> subnet5 \<noteq>
  subnet9 \<and> subnet5 \<noteq> subnet9b \<and> subnet5 \<noteq> subnet5b\<and>subnet5b \<noteq> subnet1
  \<and> subnet5b \<noteq> subnet1b \<and> subnet5b \<noteq> subnet2 \<and> subnet5b \<noteq> subnet2b \<and>
  subnet5b \<noteq> subnet3 \<and> subnet5b \<noteq> subnet3b \<and> subnet5b \<noteq> subnet4 \<and>
  subnet5b \<noteq> subnet4b \<and> subnet5b \<noteq> subnet6 \<and> subnet5b \<noteq> subnet6b \<and>
  subnet5b \<noteq> subnet7 \<and> subnet5b \<noteq> subnet7b \<and> subnet5b \<noteq> subnet8 \<and>
  subnet5b \<noteq> subnet8b \<and> subnet5b \<noteq> subnet0 \<and> subnet5b \<noteq> subnet0b \<and>
  subnet5b \<noteq> subnet9 \<and> subnet5b \<noteq> subnet9b \<and> subnet5b \<noteq> subnet5" apply
  (simp add: subnets setDaux) apply (simp add: adrs setDaux1 setDaux2)
  done


lemma nets_distinct_adr:"((b::int) < x)\<Longrightarrow>netsDistinct {{(d, e). a < d \<and> d < b}} {{(d, e). x < d \<and> d < y}}"
apply (simp add: netsDistinct_def)
apply (simp add: in_subnet_def)
done

lemma nets_distinct_adr2:"((y::int) < a)\<Longrightarrow>netsDistinct {{(d, e). a < d \<and> d < b}} {{(d, e). x < d \<and> d < y}}"
apply (simp add: netsDistinct_def)
apply (simp add: in_subnet_def)
done


lemma nets_distinct_all: " netsDistinct subnet1 subnet1b \<and>
     netsDistinct subnet1 subnet2 \<and> netsDistinct subnet1 subnet2b \<and>
     netsDistinct subnet1 subnet3 \<and> netsDistinct subnet1 subnet3b \<and>
     netsDistinct subnet1 subnet4 \<and> netsDistinct subnet1 subnet4b \<and>
     netsDistinct subnet1 subnet6 \<and> netsDistinct subnet1 subnet6b \<and>
     netsDistinct subnet1 subnet7 \<and> netsDistinct subnet1 subnet7b \<and>
     netsDistinct subnet1 subnet8 \<and> netsDistinct subnet1 subnet8b \<and>
     netsDistinct subnet1 subnet0 \<and> netsDistinct subnet1 subnet0b \<and>
     netsDistinct subnet1 subnet9 \<and> netsDistinct subnet1 subnet9b \<and>
     netsDistinct subnet1 subnet5 \<and> netsDistinct subnet1 subnet5b \<and>
     netsDistinct subnet1b subnet1 \<and> netsDistinct subnet1b subnet2 \<and>
     netsDistinct subnet1b subnet2b \<and> netsDistinct subnet1b subnet3 \<and>
     netsDistinct subnet1b subnet3b \<and> netsDistinct subnet1b subnet4 \<and>
     netsDistinct subnet1b subnet4b \<and> netsDistinct subnet1b subnet6 \<and>
     netsDistinct subnet1b subnet6b \<and> netsDistinct subnet1b subnet7 \<and>
     netsDistinct subnet1b subnet7b \<and> netsDistinct subnet1b subnet8 \<and>
     netsDistinct subnet1b subnet8b \<and> netsDistinct subnet1b subnet0 \<and>
     netsDistinct subnet1b subnet0b \<and> netsDistinct subnet1b subnet9 \<and>
     netsDistinct subnet1b subnet9b \<and> netsDistinct subnet1b subnet5 \<and>
     netsDistinct subnet1b subnet5b\<and> netsDistinct subnet2 subnet1 \<and>
     netsDistinct subnet2 subnet1b \<and> netsDistinct subnet2 subnet2b \<and>
     netsDistinct subnet2 subnet3 \<and> netsDistinct subnet2 subnet3b \<and>
     netsDistinct subnet2 subnet4 \<and> netsDistinct subnet2 subnet4b \<and>
     netsDistinct subnet2 subnet6 \<and> netsDistinct subnet2 subnet6b \<and>
     netsDistinct subnet2 subnet7 \<and> netsDistinct subnet2 subnet7b \<and>
     netsDistinct subnet2 subnet8 \<and> netsDistinct subnet2 subnet8b \<and>
     netsDistinct subnet2 subnet0 \<and> netsDistinct subnet2 subnet0b \<and>
     netsDistinct subnet2 subnet9 \<and> netsDistinct subnet2 subnet9b \<and>
     netsDistinct subnet2 subnet5 \<and> netsDistinct subnet2 subnet5b\<and>
     netsDistinct subnet2b subnet1 \<and> netsDistinct subnet2b subnet1b \<and>
     netsDistinct subnet2b subnet2 \<and> netsDistinct subnet2b subnet3 \<and>
     netsDistinct subnet2b subnet3b \<and> netsDistinct subnet2b subnet4 \<and>
     netsDistinct subnet2b subnet4b \<and> netsDistinct subnet2b subnet6 \<and>
     netsDistinct subnet2b subnet6b \<and> netsDistinct subnet2b subnet7 \<and>
     netsDistinct subnet2b subnet7b \<and> netsDistinct subnet2b subnet8 \<and>
     netsDistinct subnet2b subnet8b \<and> netsDistinct subnet2b subnet0 \<and>
     netsDistinct subnet2b subnet0b \<and> netsDistinct subnet2b subnet9 \<and>
     netsDistinct subnet2b subnet9b \<and> netsDistinct subnet2b subnet5 \<and>
     netsDistinct subnet2b subnet5b\<and> netsDistinct subnet3 subnet1 \<and>
     netsDistinct subnet3 subnet1b \<and> netsDistinct subnet3 subnet2 \<and>
     netsDistinct subnet3 subnet2b \<and> netsDistinct subnet3 subnet3b \<and>
     netsDistinct subnet3 subnet4 \<and> netsDistinct subnet3 subnet4b \<and>
     netsDistinct subnet3 subnet6 \<and> netsDistinct subnet3 subnet6b \<and>
     netsDistinct subnet3 subnet7 \<and> netsDistinct subnet3 subnet7b \<and>
     netsDistinct subnet3 subnet8 \<and> netsDistinct subnet3 subnet8b \<and>
     netsDistinct subnet3 subnet0 \<and> netsDistinct subnet3 subnet0b \<and>
     netsDistinct subnet3 subnet9 \<and> netsDistinct subnet3 subnet9b \<and>
     netsDistinct subnet3 subnet5 \<and> netsDistinct subnet3 subnet5b\<and>
     netsDistinct subnet3b subnet1 \<and> netsDistinct subnet3b subnet1b \<and>
     netsDistinct subnet3b subnet2 \<and> netsDistinct subnet3b subnet2b \<and>
     netsDistinct subnet3b subnet3 \<and> netsDistinct subnet3b subnet4 \<and>
     netsDistinct subnet3b subnet4b \<and> netsDistinct subnet3b subnet6 \<and>
     netsDistinct subnet3b subnet6b \<and> netsDistinct subnet3b subnet7 \<and>
     netsDistinct subnet3b subnet7b \<and> netsDistinct subnet3b subnet8 \<and>
     netsDistinct subnet3b subnet8b \<and> netsDistinct subnet3b subnet0 \<and>
     netsDistinct subnet3b subnet0b \<and> netsDistinct subnet3b subnet9 \<and>
     netsDistinct subnet3b subnet9b \<and> netsDistinct subnet3b subnet5 \<and>
     netsDistinct subnet3b subnet5b\<and> netsDistinct subnet4 subnet1 \<and>
     netsDistinct subnet4 subnet1b \<and> netsDistinct subnet4 subnet2 \<and>
     netsDistinct subnet4 subnet2b \<and> netsDistinct subnet4 subnet3 \<and>
     netsDistinct subnet4 subnet3b \<and> netsDistinct subnet4 subnet4b \<and>
     netsDistinct subnet4 subnet6 \<and> netsDistinct subnet4 subnet6b \<and>
     netsDistinct subnet4 subnet7 \<and> netsDistinct subnet4 subnet7b \<and>
     netsDistinct subnet4 subnet8 \<and> netsDistinct subnet4 subnet8b \<and>
     netsDistinct subnet4 subnet0 \<and> netsDistinct subnet4 subnet0b \<and>
     netsDistinct subnet4 subnet9 \<and> netsDistinct subnet4 subnet9b \<and>
     netsDistinct subnet4 subnet5 \<and> netsDistinct subnet4 subnet5b\<and>
     netsDistinct subnet4b subnet1 \<and> netsDistinct subnet4b subnet1b \<and>
     netsDistinct subnet4b subnet2 \<and> netsDistinct subnet4b subnet2b \<and>
     netsDistinct subnet4b subnet3 \<and> netsDistinct subnet4b subnet3b \<and>
     netsDistinct subnet4b subnet4 \<and> netsDistinct subnet4b subnet6 \<and>
     netsDistinct subnet4b subnet6b \<and> netsDistinct subnet4b subnet7 \<and>
     netsDistinct subnet4b subnet7b \<and> netsDistinct subnet4b subnet8 \<and>
     netsDistinct subnet4b subnet8b \<and> netsDistinct subnet4b subnet0 \<and>
     netsDistinct subnet4b subnet0b \<and> netsDistinct subnet4b subnet9 \<and>
     netsDistinct subnet4b subnet9b \<and> netsDistinct subnet4b subnet5 \<and>
     netsDistinct subnet4b subnet5b\<and> netsDistinct subnet6 subnet1 \<and>
     netsDistinct subnet6 subnet1b \<and> netsDistinct subnet6 subnet2 \<and>
     netsDistinct subnet6 subnet2b \<and> netsDistinct subnet6 subnet3 \<and>
     netsDistinct subnet6 subnet3b \<and> netsDistinct subnet6 subnet4 \<and>
     netsDistinct subnet6 subnet4b \<and> netsDistinct subnet6 subnet6b \<and>
     netsDistinct subnet6 subnet7 \<and> netsDistinct subnet6 subnet7b \<and>
     netsDistinct subnet6 subnet8 \<and> netsDistinct subnet6 subnet8b \<and>
     netsDistinct subnet6 subnet0 \<and> netsDistinct subnet6 subnet0b \<and>
     netsDistinct subnet6 subnet9 \<and> netsDistinct subnet6 subnet9b \<and>
     netsDistinct subnet6 subnet5 \<and> netsDistinct subnet6 subnet5b\<and>
     netsDistinct subnet6b subnet1 \<and> netsDistinct subnet6b subnet1b \<and>
     netsDistinct subnet6b subnet2 \<and> netsDistinct subnet6b subnet2b \<and>
     netsDistinct subnet6b subnet3 \<and> netsDistinct subnet6b subnet3b \<and>
     netsDistinct subnet6b subnet4 \<and> netsDistinct subnet6b subnet4b \<and>
     netsDistinct subnet6b subnet6 \<and> netsDistinct subnet6b subnet7 \<and>
     netsDistinct subnet6b subnet7b \<and> netsDistinct subnet6b subnet8 \<and>
     netsDistinct subnet6b subnet8b \<and> netsDistinct subnet6b subnet0 \<and>
     netsDistinct subnet6b subnet0b \<and> netsDistinct subnet6b subnet9 \<and>
     netsDistinct subnet6b subnet9b \<and> netsDistinct subnet6b subnet5 \<and>
     netsDistinct subnet6b subnet5b\<and> netsDistinct subnet7 subnet1 \<and>
     netsDistinct subnet7 subnet1b \<and> netsDistinct subnet7 subnet2 \<and>
     netsDistinct subnet7 subnet2b \<and> netsDistinct subnet7 subnet3 \<and>
     netsDistinct subnet7 subnet3b \<and> netsDistinct subnet7 subnet4 \<and>
     netsDistinct subnet7 subnet4b \<and> netsDistinct subnet7 subnet6 \<and>
     netsDistinct subnet7 subnet6b \<and> netsDistinct subnet7 subnet7b \<and>
     netsDistinct subnet7 subnet8 \<and> netsDistinct subnet7 subnet8b \<and>
     netsDistinct subnet7 subnet0 \<and> netsDistinct subnet7 subnet0b \<and>
     netsDistinct subnet7 subnet9 \<and> netsDistinct subnet7 subnet9b \<and>
     netsDistinct subnet7 subnet5 \<and> netsDistinct subnet7 subnet5b\<and>
     netsDistinct subnet7b subnet1 \<and> netsDistinct subnet7b subnet1b \<and>
     netsDistinct subnet7b subnet2 \<and> netsDistinct subnet7b subnet2b \<and>
     netsDistinct subnet7b subnet3 \<and> netsDistinct subnet7b subnet3b \<and>
     netsDistinct subnet7b subnet4 \<and> netsDistinct subnet7b subnet4b \<and>
     netsDistinct subnet7b subnet6 \<and> netsDistinct subnet7b subnet6b \<and>
     netsDistinct subnet7b subnet7 \<and> netsDistinct subnet7b subnet8 \<and>
     netsDistinct subnet7b subnet8b \<and> netsDistinct subnet7b subnet0 \<and>
     netsDistinct subnet7b subnet0b \<and> netsDistinct subnet7b subnet9 \<and>
     netsDistinct subnet7b subnet9b \<and> netsDistinct subnet7b subnet5 \<and>
     netsDistinct subnet7b subnet5b\<and> netsDistinct subnet8 subnet1 \<and>
     netsDistinct subnet8 subnet1b \<and> netsDistinct subnet8 subnet2 \<and>
     netsDistinct subnet8 subnet2b \<and> netsDistinct subnet8 subnet3 \<and>
     netsDistinct subnet8 subnet3b \<and> netsDistinct subnet8 subnet4 \<and>
     netsDistinct subnet8 subnet4b \<and> netsDistinct subnet8 subnet6 \<and>
     netsDistinct subnet8 subnet6b \<and> netsDistinct subnet8 subnet7 \<and>
     netsDistinct subnet8 subnet7b \<and> netsDistinct subnet8 subnet8b \<and>
     netsDistinct subnet8 subnet0 \<and> netsDistinct subnet8 subnet0b \<and>
     netsDistinct subnet8 subnet9 \<and> netsDistinct subnet8 subnet9b \<and>
     netsDistinct subnet8 subnet5 \<and> netsDistinct subnet8 subnet5b\<and>
     netsDistinct subnet8b subnet1 \<and> netsDistinct subnet8b subnet1b \<and>
     netsDistinct subnet8b subnet2 \<and> netsDistinct subnet8b subnet2b \<and>
     netsDistinct subnet8b subnet3 \<and> netsDistinct subnet8b subnet3b \<and>
     netsDistinct subnet8b subnet4 \<and> netsDistinct subnet8b subnet4b \<and>
     netsDistinct subnet8b subnet6 \<and> netsDistinct subnet8b subnet6b \<and>
     netsDistinct subnet8b subnet7 \<and> netsDistinct subnet8b subnet7b \<and>
     netsDistinct subnet8b subnet8 \<and> netsDistinct subnet8b subnet0 \<and>
     netsDistinct subnet8b subnet0b \<and> netsDistinct subnet8b subnet9 \<and>
     netsDistinct subnet8b subnet9b \<and> netsDistinct subnet8b subnet5 \<and>
     netsDistinct subnet8b subnet5b\<and> netsDistinct subnet0 subnet1 \<and>
     netsDistinct subnet0 subnet1b \<and> netsDistinct subnet0 subnet2 \<and>
     netsDistinct subnet0 subnet2b \<and> netsDistinct subnet0 subnet3 \<and>
     netsDistinct subnet0 subnet3b \<and> netsDistinct subnet0 subnet4 \<and>
     netsDistinct subnet0 subnet4b \<and> netsDistinct subnet0 subnet6 \<and>
     netsDistinct subnet0 subnet6b \<and> netsDistinct subnet0 subnet7 \<and>
     netsDistinct subnet0 subnet7b \<and> netsDistinct subnet0 subnet8 \<and>
     netsDistinct subnet0 subnet8b \<and> netsDistinct subnet0 subnet0b \<and>
     netsDistinct subnet0 subnet9 \<and> netsDistinct subnet0 subnet9b \<and>
     netsDistinct subnet0 subnet5 \<and> netsDistinct subnet0 subnet5b\<and>
     netsDistinct subnet0b subnet1 \<and> netsDistinct subnet0b subnet1b \<and>
     netsDistinct subnet0b subnet2 \<and> netsDistinct subnet0b subnet2b \<and>
     netsDistinct subnet0b subnet3 \<and> netsDistinct subnet0b subnet3b \<and>
     netsDistinct subnet0b subnet4 \<and> netsDistinct subnet0b subnet4b \<and>
     netsDistinct subnet0b subnet6 \<and> netsDistinct subnet0b subnet6b \<and>
     netsDistinct subnet0b subnet7 \<and> netsDistinct subnet0b subnet7b \<and>
     netsDistinct subnet0b subnet8 \<and> netsDistinct subnet0b subnet8b \<and>
     netsDistinct subnet0b subnet0 \<and> netsDistinct subnet0b subnet9 \<and>
     netsDistinct subnet0b subnet9b \<and> netsDistinct subnet0b subnet5 \<and>
     netsDistinct subnet0b subnet5b\<and> netsDistinct subnet9 subnet1 \<and>
     netsDistinct subnet9 subnet1b \<and> netsDistinct subnet9 subnet2 \<and>
     netsDistinct subnet9 subnet2b \<and> netsDistinct subnet9 subnet3 \<and>
     netsDistinct subnet9 subnet3b \<and> netsDistinct subnet9 subnet4 \<and>
     netsDistinct subnet9 subnet4b \<and> netsDistinct subnet9 subnet6 \<and>
     netsDistinct subnet9 subnet6b \<and> netsDistinct subnet9 subnet7 \<and>
     netsDistinct subnet9 subnet7b \<and> netsDistinct subnet9 subnet8 \<and>
     netsDistinct subnet9 subnet8b \<and> netsDistinct subnet9 subnet0 \<and>
     netsDistinct subnet9 subnet0b \<and> netsDistinct subnet9 subnet9b \<and>
     netsDistinct subnet9 subnet5 \<and> netsDistinct subnet9 subnet5b\<and>
     netsDistinct subnet9b subnet1 \<and> netsDistinct subnet9b subnet1b \<and>
     netsDistinct subnet9b subnet2 \<and> netsDistinct subnet9b subnet2b \<and>
     netsDistinct subnet9b subnet3 \<and> netsDistinct subnet9b subnet3b \<and>
     netsDistinct subnet9b subnet4 \<and> netsDistinct subnet9b subnet4b \<and>
     netsDistinct subnet9b subnet6 \<and> netsDistinct subnet9b subnet6b \<and>
     netsDistinct subnet9b subnet7 \<and> netsDistinct subnet9b subnet7b \<and>
     netsDistinct subnet9b subnet8 \<and> netsDistinct subnet9b subnet8b \<and>
     netsDistinct subnet9b subnet0 \<and> netsDistinct subnet9b subnet0b \<and>
     netsDistinct subnet9b subnet9 \<and> netsDistinct subnet9b subnet5 \<and>
     netsDistinct subnet9b subnet5b\<and> netsDistinct subnet5 subnet1 \<and>
     netsDistinct subnet5 subnet1b \<and> netsDistinct subnet5 subnet2 \<and>
     netsDistinct subnet5 subnet2b \<and> netsDistinct subnet5 subnet3 \<and>
     netsDistinct subnet5 subnet3b \<and> netsDistinct subnet5 subnet4 \<and>
     netsDistinct subnet5 subnet4b \<and> netsDistinct subnet5 subnet6 \<and>
     netsDistinct subnet5 subnet6b \<and> netsDistinct subnet5 subnet7 \<and>
     netsDistinct subnet5 subnet7b \<and> netsDistinct subnet5 subnet8 \<and>
     netsDistinct subnet5 subnet8b \<and> netsDistinct subnet5 subnet0 \<and>
     netsDistinct subnet5 subnet0b \<and> netsDistinct subnet5 subnet9 \<and>
     netsDistinct subnet5 subnet9b \<and> netsDistinct subnet5 subnet5b\<and>
     netsDistinct subnet5b subnet1 \<and> netsDistinct subnet5b subnet1b \<and>
     netsDistinct subnet5b subnet2 \<and> netsDistinct subnet5b subnet2b \<and>
     netsDistinct subnet5b subnet3 \<and> netsDistinct subnet5b subnet3b \<and>
     netsDistinct subnet5b subnet4 \<and> netsDistinct subnet5b subnet4b \<and>
     netsDistinct subnet5b subnet6 \<and> netsDistinct subnet5b subnet6b \<and>
     netsDistinct subnet5b subnet7 \<and> netsDistinct subnet5b subnet7b \<and>
     netsDistinct subnet5b subnet8 \<and> netsDistinct subnet5b subnet8b \<and>
     netsDistinct subnet5b subnet0 \<and> netsDistinct subnet5b subnet0b \<and>
     netsDistinct subnet5b subnet9 \<and> netsDistinct subnet5b subnet9b \<and>
     netsDistinct subnet5b subnet5" 
 apply (simp add: setDaux1 setDaux2 nets_distinct_aux subnets adrs nets_distinct_adr nets_distinct_adr2) 
done


lemma ANDex10: "allNetsDistinct (policy2list filter_10)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex2: "allNetsDistinct (policy2list filter_2)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex3: "allNetsDistinct (policy2list filter_3)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex4: "allNetsDistinct (policy2list filter_4)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex5: "allNetsDistinct (policy2list filter_5)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex6: "allNetsDistinct (policy2list filter_6)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex7: "allNetsDistinct (policy2list filter_7)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex8: "allNetsDistinct (policy2list filter_8)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done

lemma ANDex9: "allNetsDistinct (policy2list filter_9)"
apply (simp add: UnfoldPolicy10)
apply (auto simp: allNetsDistinct_def nets_different_all nets_distinct_all)
done



lemma domDAh[simp]: " dom D\<^sub>U {}" 
apply (auto simp: PLemmas)
done




lemma  domMT5a: "\<lbrakk>y \<in> dom nat2; y\<in> dom D\<rbrakk> \<Longrightarrow> 
y \<in> dom (g o_f ((nat2 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x))))"
apply (simp add: UPFDefs dom_def)
apply auto
apply (simp split: option.splits decision.splits prod.splits add: PLemmas)
done

lemma  domMT5b: "\<lbrakk>y \<in> dom nat2; y \<notin> dom D\<rbrakk> \<Longrightarrow> 
y \<notin> dom (g o_f ((nat2 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x))))"
apply (simp add: UPFDefs dom_def)
apply auto
apply (simp split: option.splits decision.splits prod.splits add: PLemmas)
done



lemma  domMT5: "dom nat2 = UNIV \<Longrightarrow> 
 dom (g o_f ((nat2 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (rule set_eqI)
apply (subgoal_tac "x\<in>dom nat2")
apply (rule iffI)
apply (simp_all add: domMT5b domMT5a)
by (metis UNIV_I domMT5b)



(* policy2 *)


lemma noMT2: "\<forall> x \<in> set (policy2list filter_2). dom (C x) \<noteq>  {}" 
apply (simp add: UnfoldPolicy2 subnets)
apply (rule conjI) 
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done




lemma all_in_list2: "all_in_list (policy2list filter_2) (Nets_List filter_2)"
apply (simp add: UnfoldPolicy2)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert nets_different_all,simp)
done

lemma dom_nat2: "dom nat_2 = UNIV"
apply (simp add: UnfoldPolicy2 adrs)
apply auto
done


lemma  domMT2: " 
 dom (g o_f ((nat_2 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat2)
done


lemma domUniv: "x \<in> dom policy_2"
apply (simp add:  policy_2_def filter_4_def filter_3_def filter_2_def 
                   filter_1_def filter_0_def  )
apply (simp add: dom_nat2 domMT2 NormalisationIntegerPortProof.domain_reasoning)
done


(* policy_03 *)

lemma noMT3: "\<forall> x \<in> set (policy2list filter_3). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy3 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done




lemma all_in_list3: "all_in_list (policy2list filter_3) (Nets_List filter_3)"
apply (simp add: UnfoldPolicy3)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert nets_different_all,simp)
done

lemma dom_nat3: "dom nat_3 = UNIV"
apply (simp add: UnfoldPolicy3 adrs)
apply auto
done


lemma  domMT3: " 
 dom (g o_f ((nat_3 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat3)
done


lemma domUniv3: "x \<in> dom policy_3"
apply (simp add: policy_3_def filter_3_def filter_2_def 
                  filter_1_def filter_0_def  )
apply (simp add: dom_nat3 domMT3 domain_reasoning)
done


(* policy_04 *)

lemma noMT4: "\<forall> x \<in> set (policy2list filter_4). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy4 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done




lemma all_in_list4: "all_in_list (policy2list filter_4) (Nets_List filter_4)"
apply (simp add: UnfoldPolicy4)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert nets_different_all,simp)
done

lemma dom_nat4: "dom nat_4 = UNIV"
apply (simp add: UnfoldPolicy4 adrs)
apply auto
done


lemma  domMT4: " 
 dom (g o_f ((nat_4 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat4)
done


lemma domUniv4: "x \<in> dom policy_4"
apply (simp add: policy_4_def filter_4_def filter_3_def filter_2_def 
                  filter_1_def filter_0_def  )
apply (simp add: dom_nat4 domMT4 domain_reasoning)
done





(* policy_05 *)

lemma noMT5: "\<forall> x \<in> set (policy2list filter_5). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy5 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done




lemma all_in_list5: "all_in_list (policy2list filter_5) (Nets_List filter_5)"
apply (simp add: UnfoldPolicy5)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert nets_different_all,simp)
done

lemma dom_nat5: "dom nat_5 = UNIV"
apply (simp add: UnfoldPolicy5 adrs)
apply auto
done


lemma  domMT55: " 
 dom (g o_f ((nat_5 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat5)
done


lemma domUniv5: "x \<in> dom policy_5"
apply (simp add: policy_5_def filter_5_def filter_2_def  filter_4_def filter_3_def
                  filter_1_def filter_0_def  )
apply (simp add: dom_nat5 domMT55 domain_reasoning)
done








(* policy6 *)


lemma noMT6: "\<forall> x \<in> set (policy2list filter_6). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy6 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done




lemma all_in_list6: "all_in_list (policy2list filter_6) (Nets_List filter_6)"
apply (simp add: UnfoldPolicy6)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert  nets_different_all,simp)
done

lemma dom_nat6: "dom nat_6 = UNIV"
apply (simp add: UnfoldPolicy6 adrs)
apply auto
done


lemma  domMT66: " 
 dom (g o_f ((nat_6 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat6)
done


lemma domUniv6: "x \<in> dom policy_6"
apply (simp add: policy_6_def filters  )
apply (simp add: dom_nat6 domMT66 domain_reasoning)
done


(*policy 7 *)

lemma noMT7: "\<forall> x \<in> set (policy2list filter_7). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy7 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done




lemma all_in_list7: "all_in_list (policy2list filter_7) (Nets_List filter_7)"
apply (simp add: UnfoldPolicy7)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert  nets_different_all,simp)
done

lemma dom_nat7: "dom nat_7 = UNIV"
apply (simp add: UnfoldPolicy7 adrs)
apply auto
done


lemma  domMT77: " 
 dom (g o_f ((nat_7 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat7)
done


lemma domUniv7: "x \<in> dom policy_7"
apply (simp add: policy_7_def filters  )
apply (simp add: dom_nat7 domMT77 domain_reasoning)
done




(* policy_08 *)

lemma noMT8: "\<forall> x \<in> set (policy2list filter_8). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy8 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done




lemma all_in_list8: "all_in_list (policy2list filter_8) (Nets_List filter_8)"
apply (simp add: UnfoldPolicy8)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert  nets_different_all,simp)
done

lemma dom_nat8: "dom nat_8 = UNIV"
apply (simp add: UnfoldPolicy8 adrs)
apply auto
done


lemma  domMT88: " 
 dom (g o_f ((nat_8 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat8)
done


lemma domUniv8: "x \<in> dom policy_8"
apply (simp add: policy_8_def filters)
apply (simp add: dom_nat8 domMT88 domain_reasoning)
done


(* policy 9 *)


lemma noMT9: "\<forall> x \<in> set (policy2list filter_9). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy9 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs)
apply auto
apply arith+
done



lemma all_in_list9: "all_in_list (policy2list filter_9) (Nets_List filter_9)"
apply (simp add: UnfoldPolicy9)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert  nets_different_all,simp)
done

lemma dom_nat9: "dom nat_9 = UNIV"
apply (simp add: UnfoldPolicy9 adrs)
apply auto
done


lemma  domMT99: " 
 dom (g o_f ((nat_9 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat9)
done


lemma domUniv9: "x \<in> dom policy_9"
apply (simp add: policy_9_def filters)
apply (simp add: dom_nat9 domMT99 domain_reasoning)
done




(* policy 10 *)


lemma noMT10: "\<forall> x \<in> set (policy2list filter_10). dom (C x)  \<noteq> {}" 
apply (simp add: UnfoldPolicy10 subnets)
apply (rule conjI)
apply (metis NormalisationIntegerPortProof.DAnMT)
apply (simp add: PLemmas adrs  )
apply auto
apply arith+
done



lemma all_in_list10: "all_in_list (policy2list filter_10) (Nets_List filter_10)"
apply (simp add: UnfoldPolicy10)
apply (unfold Nets_List_def)
apply (unfold bothNets_def)
apply (insert  nets_different_all,simp)
done

lemma dom_nat10: "dom nat_10 = UNIV"
apply (simp add: UnfoldPolicy10 adrs)
apply auto
done


lemma  domMT1010: " 
 dom (g o_f ((nat_10 \<Otimes>\<^sub>2 D) o   (\<lambda>x. (x, x)))) = dom D"
apply (simp add: domMT5 dom_nat10)
done


lemma domUniv10: "x \<in> dom policy_10"
apply (simp add: policy_10_def filters)
apply (simp add: dom_nat10 domMT1010 domain_reasoning)
done



end
